
local offset = vector.new(4, 4)

local ball = {}

function ball.create(x, y, r, speed, colour)
   x = x or 0
   y = y or 0
   r = r or 0
   speed = speed or 1
   colour = colour or 15
   
   local b = {}
   b.pos = vector.new(x, y)
   local dir = vector.new(0, -1)
   b.rot = r
   b.dir = dir:rotated(r)
   b.speed = speed
   b.colour = colour
   b.velocity = b.dir * b.speed
   
   b.isPotted = false
   
   b.setRotation = ball._setRotation
   b.setSpeed = ball._setSpeed
   b.calcSpeed = ball._calcSpeed
	b.getDirection = ball._getDirection
   
   b.getCentre = ball._getCentre
   b.draw = ball._draw
   return b
end

function ball._draw(b)
    if not b.isPotted then
        local pos = b:getCentre()
        local x = math.floor(pos.x)
        local y = math.floor(pos.y)
        
        love.graphics.setColor(palette[b.colour])
        love.graphics.circle("fill", x, y, 4)
        --love.graphics.setColor(palette[0])
        --love.graphics.rectangle("line", x - 3.5, y - 3.5, 6, 6)
    end
end

function ball._getCentre(b, n)
    if n then
        return b.npos + offset
    else
        return b.pos + offset
    end
end

function ball._setRotation(b, r)
    local dir = vector.new(0, -1)
    b.dir = dir:rotated(r)
end

function ball._setSpeed(b, speed)
    b.speed = speed
    b.velocity = b.dir * b.speed
end

function ball._calcSpeed(b)
   return b.velocity:length() 
end

function ball._getDirection(b)
	return b.velocity:normalized()
end

return ball
