
require "util/palettes"

vector = require "util/vector2d"
b = require "ball"
holes = require "hole"

--TODO
-- Create nice title and winning screens
-- publish

FPS = 25 -- haha PAL
T = 1 / FPS

SW = 256
SH = 192

WIDTH  = 320
HEIGHT = 240

RNG = love.math.newRandomGenerator()

local dx = (WIDTH / 2) - (SW / 2)
local dy = (HEIGHT / 2) - (SH / 2)

local sx = 800 / WIDTH
local sy = 600 / HEIGHT

local screen
local display
local interim

local g = love.graphics

local timer = 0
local isTV = true

palette = PAL[1]
font = nil

--local game = require "threeball"
local nextGame = "title"
local players = 0
local change = false
local game = require(nextGame)

function love.load()
    love.keyboard.setKeyRepeat(true)
    
    font = love.graphics.newFont("halfeighties.ttf", 16)
    
    display = g.newCanvas(WIDTH, HEIGHT)
    screen = g.newCanvas(SW, SH)
    interim = g.newCanvas(WIDTH / 2, HEIGHT)

	__setFilter(false, false)
end

function love.update(dt)
    RNG:random()
    if change then
       change = false
       game = require(nextGame)
       game.reset(players)
    end
    timer = timer + dt
    while timer >= T do
        game.update()
        timer = timer - T
    end
end

function love.draw()
    g.setCanvas(screen)
    g.clear(palette[0])
    
    local fnt = g.getFont()
    g.setFont(font)
    
    -- Game drawing
    game.draw()
    
    g.setFont(fnt)
    g.setCanvas(display)
    g.clear(palette[0])
    g.setColor(1, 1, 1)
    g.draw(screen, dx, dy)
    
    if isTV then
        g.setCanvas(interim)
        g.draw(display, 0, 0, 0, 0.5, 1)
        g.setCanvas(display)
        g.draw(interim, 0, 0, 0, 2, 1)
    end
    
    g.setCanvas()
    g.draw(display, 0, 0, 0, sx, sy)
    
    g.setColor(1, 0, 0)
    g.print("FPS: " .. love.timer.getFPS())
    
end

function __setFilter(bilin, tv)
    local f = bilin and "linear" or "nearest"
    display:setFilter(f, f)
    isTV = tv
end

function switchExecution(next, param)
    players = param or 0
    nextGame = next
    change = true
end

function love.keypressed(key, scnacode, isrepeat)
    if key == "f1" then
       palette = PAL[1] 
    elseif key == "f2" then
        palette = PAL[2]
    elseif key == "f3" then
        palette = PAL[3]
    elseif key == "f4" then
        palette = PAL[4]
    end
    
    if key == "f5" then
        __setFilter(false, false)
    elseif key == "f6" then
        __setFilter(true, false)
    elseif key == "f7" then
        __setFilter(true, true)
    end
    
    game.keypressed(key, scancode, isrepeat)
end

function love.keyreleased(key, scancode)
   game.keyreleased(key, scancode) 
end
