 
local title = {}

local g = love.graphics

local state = "GAMETYPE"
local players = 1

local selects = 1
local OFF_Y = 88

function title._exit()
    love.event.quit(0)
end

function title._pool()
    --switchExecution("threeball", 2)
	state = "POOL"
	selects = 1
end

function title._fool()
	selects = 1
	state = "FOOL"
end

local selections = {}
table.insert(selections, "Play the boring old pool game.")
table.insert(selections, "Play new exiting FOOL!")
table.insert(selections, "Exit")

local fn = {}
table.insert(fn, title._pool)
table.insert(fn, title._fool)
table.insert(fn, title._exit)

function title.update() end

function title.reset()
	state = "GAMETYPE"
    selects = 1
end

function title.draw()
	g.clear(palette[0])
	g.setColor(palette[15])

	if state == "GAMETYPE" then
		
		for i, s in ipairs(selections) do
			g.print(s, 8, OFF_Y + (i * 8))
		end

		g.print(">", 0, OFF_Y +(selects * 8))
	elseif state == "POOL" or state == "FOOL" then
		g.print("Threeball", 8, 96)
		g.print("Blackball", 8, 104)
		g.print(">", 0, OFF_Y +(selects * 8))
	elseif state == "P3BALL" or state == "F3BALL" then
		g.print("Select players", 72, 96)
		g.print(players, 128, 104)
	end
end

function title.keypressed(key, scancode, isrepeat)
	if state == "GAMETYPE" then
		if key == "up" then
			selects = selects - 1
			selects = selects < 1 and selects + #selections or selects
		elseif key == "down" then
			selects = selects + 1
			selects = selects > #selections and selects - #selections or selects
		end
	elseif state == "POOL" or state == "FOOL" then
		if key == "up" then
			selects = selects - 1
			selects = selects < 1 and selects + 2 or selects
		elseif key == "down" then
			selects = selects + 1
			selects = selects > 2 and selects - 2 or selects
		end
	elseif state == "P3BALL" or state == "F3BALL" then
		if key == "left" or key == "down" then
			players = players - 1
			players = players < 1 and 1 or players
		elseif key == "right" or key == "up" then
			players = players + 1
			players = players > 6 and 6 or players
		end
	end
end

function title.keyreleased(key, scancode, isrepeat)
	if state == "GAMETYPE" then
		if key == "return" or key == "enter" then
			fn[selects]() 
		end
	elseif state == "POOL" then
		if key == "return" or key == "enter" then
			--switchExecution("threeball", 2)
			players = 2
			if selects == 1 then
				state = "P3BALL"
			else
				switchExecution("blackball", 2)
			end
		end

		if key == "escape" then
			selects = 1
			state = "GAMETYPE"
		end
	elseif state == "FOOL" then
		if key == "return" or key == "enter" then
			players = 2
			if selects == 1 then
				state = "F3BALL"
			else
				switchExecution("blackfool", 2)
			end
		end

		if key == "escape" then
			selects = 1
			state = "GAMETYPE"
		end
	elseif state == "P3BALL" then
		if key == "return" or key == "enter" then
			switchExecution("threeball", players)
		end

		if key == "escape" then
			selects = 1
			state = "POOL"
		end
	elseif state == "F3BALL" then
		if key == "return" or key == "enter" then
			switchExecution("threefool", players)
		end

		if key == "escape" then
			selects = 2
			state = "FOOL"
		end
	end
end

return title
