 
PAL = {}

function __norm_colour(c)
    return {c[1] / 255, c[2] / 255, c[3] / 255, 1}
end

function __make_palette(idx, p)
    PAL[idx] = {}
    for i = 0, 15 do
        PAL[idx][i] = __norm_colour(p[i])
    end
end

function __createMono(idx, p)
    PAL[idx] = {}
    for i = 0, 15 do
        c = __norm_colour(p[i])
        local y = 0.2126*c[1] + 0.7152*c[2] + 0.0722*c[3]
        local c2 = {y, y, y, 1}
        PAL[idx][i] = c2
    end
end

-- ZX-A

p = {}
p[0] = {0 , 0, 0}       --DARK BLACK
p[1] = {49, 51, 144}     --DARK BLUE
p[2] = {167, 50, 17}    --DARK RED
p[3] = {161, 85, 137}   --DARK MAGENTA
p[4] = {98, 154, 49}     --DARK GREEN
p[5] = {40, 164, 203}    --DARK CYAN
p[6] = {232, 188, 80}   --DARK YELLOW
p[7] = {191, 191, 189}  --DARK WHITE

p[8] = {60, 53, 31}        --BLACK
p[9] = {21, 89, 219}      --BLUE
p[10] = {216, 85, 37}    --RED
p[11] = {205, 122, 80}   --MAGENTA
p[12] = {156, 211, 60}     --GREEN
p[13] = {101, 220, 214}    --CYAN
p[14] = {241, 231, 130}   --YELLOW
p[15] = {242, 241, 237}  --WHITE

__make_palette(1, p)

-- ZX-Spectrum

local p = {}
p[0] = {0 , 0, 0}       --DARK BLACK
p[1] = {0, 34, 199}     --DARK BLUE
p[2] = {214, 40, 22}    --DARK RED
p[3] = {212, 51, 199}   --DARK MAGENTA
p[4] = {0, 197, 37}     --DARK GREEN
p[5] = {0, 199, 201}    --DARK CYAN
p[6] = {204, 200, 42}   --DARK YELLOW
p[7] = {202 ,202, 202}  --DARK WHITE

p[8] = {0 , 0, 0}        --BLACK
p[9] = {0, 43, 251}      --BLUE
p[10] = {255, 51, 28}    --RED
p[11] = {255, 64, 252}   --MAGENTA
p[12] = {0, 249, 47}     --GREEN
p[13] = {0, 251, 254}    --CYAN
p[14] = {255, 252, 54}   --YELLOW
p[15] = {255, 255, 255}  --WHITE

__make_palette(2, p)

-- CGA

p = {}
p[0] = {0 , 0, 0}       --DARK BLACK
p[1] = {0, 0, 170}     --DARK BLUE
p[2] = {170, 0, 0}    --DARK RED
p[3] = {170, 0, 170}   --DARK MAGENTA
p[4] = {0, 170, 0}     --DARK GREEN
p[5] = {0, 170, 170}    --DARK CYAN
p[6] = {170, 85, 0}   --DARK YELLOW
p[7] = {170, 170, 170}  --DARK WHITE

p[8] = {85, 85, 85}        --BLACK
p[9] = {85, 85, 255}      --BLUE
p[10] = {255, 85, 85}    --RED
p[11] = {255, 85, 255}   --MAGENTA
p[12] = {85, 255, 85}     --GREEN
p[13] = {85, 255, 255}    --CYAN
p[14] = {255, 255, 85}   --YELLOW
p[15] = {255, 255, 255}  --WHITE

__make_palette(3, p)
__createMono(4, p)
